datablock ParticleData(ZweihanderBeamChargedParticle)
{
        dragCoefficient      = 3;
        gravityCoefficient   = -0.0;
        inheritedVelFactor   = 0.0;
        constantAcceleration = 0.0;
        lifetimeMS           = 150;
        lifetimeVarianceMS   = 0;
        textureName          = "base/data/particles/cloud";
        spinSpeed                = 10.0;
        spinRandomMin                = -150.0;
        spinRandomMax                = 150.0;
        colors[0]     = "0.0 0.1 1 1";
        colors[1]     = "0.5 0.5 0.5 0";
        sizes[0]      = 0.50;
        sizes[1]      = 0.25;

        useInvAlpha = false;
};
datablock ParticleEmitterData(ZweihanderBeamChargedEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ZweihanderBeamChargedParticle";

};

datablock ParticleData(ZweihanderBeamFireParticle)
{
        dragCoefficient      = 3;
        gravityCoefficient   = -0.0;
        inheritedVelFactor   = 0.0;
        constantAcceleration = 0.0;
        lifetimeMS           = 150;
        lifetimeVarianceMS   = 0;
        textureName          = "base/data/particles/star1";
        spinSpeed                = 10.0;
        spinRandomMin                = -150.0;
        spinRandomMax                = 150.0;
        colors[0]     = "0.0 0.1 1 1";
        colors[1]     = "0.5 0.5 0.5 0";
        sizes[0]      = 0.50;
        sizes[1]      = 0.25;

        useInvAlpha = false;
};

datablock ParticleData(ZweihanderBladeBeamExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/star1";
        colors[0]     = "0.0 0.1 1 1";
        colors[1]     = "0.5 0.5 0.5 0";
        sizes[0]      = 0.50;
        sizes[1]      = 0.25;
};

datablock ParticleEmitterData(ZweihanderBladeBeamExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ZweihanderBladeBeamExplosionParticle";

};

datablock ParticleEmitterData(ZweihanderBeamFireEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ZweihanderBeamFireParticle";

};

datablock ParticleData(CLBladeExplosionParticle)
{
	dragCoefficient			= 2;
	gravityCoefficient		= 0.8;
	inheritedVelFactor		= 0.0;
	constantAcceleration	= 0.0;
	spinRandomMin			= -200;
	spinRandomMax			= 200;
	lifetimeMS				= 1000;
	lifetimeVarianceMS		= 100;

	textureName	= "base/data/particles/chunk";

	useinvAlpha	= 1;
	sizes[0]	= 0.8;
	sizes[1]	= 0.8;
	times[0]	= 0.0;
	times[1]	= 1.0;
	colors[0]	= "0.7 0.7 0.7 0.9";
	colors[1]	= "0.7 0.7 0.7 0.0";
};

datablock ParticleEmitterData(CLBladeExplosionEmitter)
{
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 10;
	velocityVariance	= 4.0;
	ejectionOffset		= 0.2;
	thetaMin			= 60;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles	= "CLBladeExplosionParticle";
	uiname		= "CL Blade Explosion";
};

datablock ParticleData(CLBladeTrailParticle)
{
	dragCoefficient			= 2;
	gravityCoefficient		= 0.2;
	inheritedVelFactor		= -1.0;
	constantAcceleration	= -0.2;
	spinRandomMin			= -600;
	spinRandomMax			= 600;
	lifetimeMS				= 600;
	lifetimeVarianceMS		= 200;

	textureName	= "base/data/particles/cloud";

	useinvAlpha	= 1;
	sizes[0]	= 0.3;
	sizes[1]	= 1.2;
	times[0]	= 0.0;
	times[1]	= 1.0;
	colors[0]	= "0.3 0.3 0.3 0.8";
	colors[1]	= "0.2 0.2 0.2 0.0";
};

datablock ParticleEmitterData(CLBladeTrailEmitter)
{
	ejectionPeriodMS	= 50;
	periodVarianceMS	= 0;
	ejectionVelocity	= 3.0;
	velocityVariance	= 1.5;
	ejectionOffset		= 0.5;
	thetaMin			= 60;
	thetaMax			= 180;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;

	particles	= "CLBladeTrailParticle";
	uiname		= "CL Blade Trail";
};

datablock ExplosionData(ZweihanderBladeBeamExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;
   soundProfile = CLBladeHitSound;


   particleEmitter = ZweihanderBladeBeamExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};

//projectile
datablock ProjectileData(ZweihanderBladeBeamProjectile)
{
	projectileShapeName = "./BladeBeam.dts";
   directDamage        = 50;
   directDamageType  = $DamageType::CLBlade;
   explosion           = ZweihanderBladeBeamExplosion;
   //particleEmitter     = as;

	 ImpactImpulse		= 500;
	 verticleImpulse	= 300;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   explodeondeath = true;

   armingDelay         = 0;
   lifetime            = 2350;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0.5 0.5 0.5";
};

datablock ExplosionData(CLBladeExplosion)
{
	lifeTimeMS	= 600;

	soundProfile	= CLBladeHitSound;

	particleEmitter	= CLBladeExplosionEmitter;
	particleDensity	= 30;
	particleRadius	= 0.5;

	faceViewer		= true;
	explosionScale	= "1 1 1";

	shakeCamera			= true;
	camShakeFreq		= "20.0 22.0 20.0";
	camShakeAmp			= "1.0 1.0 1.0";
	camShakeDuration	= 2.0;
	camShakeRadius		= 25.0;

	lightStartRadius	= 0;
	lightEndRadius		= 2;
	lightStartColor		= "0.4 1.0 0.4";
	lightEndColor		= "0 0 0";
};

AddDamageType("CLBlade",   '<bitmap:add-ons/Weapon_William/CI_Blade> %1',    '%2 <bitmap:add-ons/Weapon_William/CI_Blade> %1',0.75,1);
AddDamageType("CLBladeRanged",   '<bitmap:add-ons/Weapon_William/CI_Blade> %1',    '%2 <bitmap:add-ons/Weapon_William/CI_Blade> %1',0.75,1);
datablock ProjectileData(CLBladeProjectile)
{
	directDamage		= 100;
	directDamageType	= $DamageType::CLBlade;
	radiusDamageType	= $DamageType::CLBlade;
	explosion			= CLBladeExplosion;
	//particleEmitter		= CLBladeTrailEmitter;
	ImpactImpulse		= 750;
	verticleImpulse	= 400;

	muzzleVelocity		= 100;
	velInheritFactor	= 1;

	armingDelay			= 0;
	lifetime			= 100;
	fadeDelay			= 70;
	bounceElasticity	= 0;
	bounceFriction		= 0;
	isBallistic			= false;
	gravityMod			= 0.0;

	hasLight	= false;
	lightRadius	= 15.0;
	lightColor	= "0 0 0";
};

datablock ItemData(CLBladeItem)
{
	category	= "Weapon";
	className	= "Weapon";

	shapeFile	= "./Blade.dts";
	mass		= 1;
	density		= 0.2;
	elasticity	= 0.2;
	friction	= 0.6;
	emap		= true;

	uiName			= "William Sword";
	iconName		= "./icon_blade";
	doColorShift	= false;
	colorShiftColor	= "0.0 0.0 0.0 1.000";

	image	= CLBladeImage;
	canDrop	= true;
};

datablock ShapeBaseImageData(CLBladeImage)
{
	shapeFile	= "./Blade.dts";
	emap		= true;

	mountPoint	= 0;
	offset		= "0 0 0";

	correctMuzzleVector	= false;

	eyeOffset	= "0 0 0";

	className	= "WeaponImage";

	item			= CLBladeItem;
	ammo			= " ";
	projectile		= CLBladeProjectile;
	projectileType	= Projectile;

	melee			= true;
	doRetraction	= false;
	armReady		= false;

	doColorShift	= true;
	colorShiftColor	= "0.0 0.0 0.0 1.000";

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0] 			= "idle";
	stateSound[0]				= "CLBladeDrawSound";

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;

	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Charged";
	stateTimeoutValue[2]            = 0.7;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "PreFire";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;

	stateName[3]					= "Charged";
	stateEmitter[3]					= ZweihanderBeamChargedEmitter; //WACKY EFFECTS
	stateEmitterTime[3]				= 0.75;
	stateEmitterNode[3]				= "swordEmitt";
	stateTransitionOnTriggerUp[3]	= "PreBladeBeam";
	stateAllowImageChange[3]		= false;

	stateName[4]					= "PreFire";
	stateSequence[4]				= "startLag";
	stateTransitionOnTimeout[4]		= "Fire";
	stateTimeoutValue[4]			= 0.20;
	stateFire[4]					= false;
	stateScript[4]					= "";
	stateWaitForTimeout[4]			= true;
	stateAllowImageChange[4]		= false;
	stateSound[4]					= CLBladeSwingSound; //williams default attack

	stateName[5]					= "Fire";
	stateEmitter[5]					= "";
	stateEmitterTime[5]				= 0;
	stateEmitterNode[5]				= "swordEmitt";
	stateSequence[5]				= "attack";
	stateTransitionOnTimeout[5]		= "PostFire";
	stateTimeoutValue[5]			= 0.15;
	stateFire[5]					= true;
	stateScript[5]					= "onFire";
	stateWaitForTimeout[5]			= true;
	stateAllowImageChange[5]		= false;
	stateSound[5]					= "";

	stateName[6]					= "PostFire";
	stateSequence[6]				= "";
	stateTransitionOnTimeout[6]		= "ReturnFire";
	stateTimeoutValue[6]			= 0.20;
	stateFire[6]					= false;
	stateScript[6]					= "";
	stateWaitForTimeout[6]			= true;
	stateAllowImageChange[6]		= false;
	stateSound[6]					= "";

	stateName[7]					= "ReturnFire";
	stateSequence[7]				= "return";
	stateTransitionOnTimeout[7]		= "Ready";
	stateTimeoutValue[7]			= 0.25;
	stateFire[7]					= false;
	stateScript[7]					= "";
	stateWaitForTimeout[7]			= true;
	stateAllowImageChange[7]		= false;
	stateSound[7]					= "";

	stateName[8]					= "PreBladeBeam";
	stateEmitter[8]					= "";
	stateEmitterTime[8]				= 0;
	stateEmitterNode[8]				= "swordEmitt";
	stateSequence[8]				= "startLag";
	stateTransitionOnTimeout[8]		= "BladeBeam";
	stateTimeoutValue[8]			= 0.3;
	stateScript[8]					= "";
	stateWaitForTimeout[8]			= true;
	stateAllowImageChange[8]		= false;
	stateSound[8]					= CLJumpSound; // some swhing sound (magical)

	stateName[9]					= "BladeBeam";
	stateEmitter[9]					= "";
	stateEmitterTime[9]				= 0;
	stateEmitterNode[9]				= "swordEmitt";
	stateSequence[9]				= "attack";
	stateTransitionOnTimeout[9]		= "PostBladeBeam";
	stateTimeoutValue[9]			= 0.15;
	stateScript[9]					= "onBladeBeam";
	stateWaitForTimeout[9]			= true;
	stateAllowImageChange[9]		= false;
	stateSound[9]					= "";

	stateName[10]					= "PostBladeBeam";
	stateEmitter[10]					= "";
	stateEmitterTime[10]				= 0;
	stateEmitterNode[10]				= "swordEmitt";
	stateSequence[10]				= "";
	stateTransitionOnTimeout[10]		= "ReturnBladeBeam";
	stateTimeoutValue[10]			= 0.3;
	stateScript[10]					= "";
	stateWaitForTimeout[10]			= true;
	stateAllowImageChange[10]		= false;
	stateSound[10]					= "";

	stateName[11]					= "ReturnBladeBeam";
	stateEmitter[11]					= "";
	stateEmitterTime[11]				= 0;
	stateEmitterNode[11]				= "swordEmitt";
	stateSequence[11]				= "return";
	stateTransitionOnTimeout[11]		= "Ready";
	stateTimeoutValue[11]			= 0.5;
	stateScript[11]					= "";
	stateWaitForTimeout[11]			= true;
	stateAllowImageChange[11]		= false;
	stateSound[11]					= "";
};

function CLBladeImage::onBladeBeam(%this, %obj, %slot)
{
	%projectile = ZweihanderBladeBeamProjectile;
	%shellcount = 1;

		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);

			%p = new Projectile()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
				startTime = $sim::time;
			};
			MissionCleanup.add(%p);
		}
	return %p;
}

function CLBladeImage::onFire(%this, %obj, %slot)
{
	%obj.hidenode("RHand");
    %obj.hidenode("LHand");
	%obj.playThread(2, armReadyRight);

	%damageScale = getWord(%obj.getScale(), 2);
	%pos = %obj.getPosition();
	%height = getWord(%obj.getDatablock().boundingBox, 2);
	%hackPosition = vectorAdd(%pos, "0 0" SPC %height * 0.5);
	%searchPosition = vectorAdd(%hackPosition, vectorScale(%obj.getEyeVector(), 2 * %damageScale));

	initContainerRadiusSearch(%searchPosition, 0.5 * %damageScale, $typeMasks::playerObjectType | $typeMasks::vehicleObjectType);

	while(isObject(%search = containerSearchNext()))
	{
		if(%search == %obj)
		{
			continue;
		}

		//if(isObstruction(%obj.getHackPosition(), %search))
		//{
		//	continue;
		//}

		if(!minigameCanDamage(%obj, %search))
			continue;

		%search.damage(%obj, %searchPosition, 30 * %damageScale, $DamageType::CLBlade);
	}

	parent::onFire(%this, %obj, %slot);
}

function CLBladeImage::onMount(%this, %obj, %slot)
{
	%obj.hidenode("RHand");
    %obj.hidenode("LHand");
	%obj.playThread(2, armReadyRight);
}


function CLBladeImage::onUnMount(%this, %obj, %slot)
{
	%obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
	%obj.playThread(2, root);
}

function ZweihanderBladeBeamProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	%directDamage = %this.directDamage + (200 - mAbs(($sim::time - %obj.startTime - 1) * 200));

	if(%directDamage <= 0)
		return;

	%damageType = $DamageType::Direct;
	if(%this.DirectDamageType)
		%damageType = %this.DirectDamageType;

	%scale = getWord(%obj.getScale(), 2);
	%directDamage = %directDamage * %scale;

	%col.damage(%obj, %pos, %directDamage, %damageType);
}
